IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('ARTEFACT_VIEW') AND OBJECTPROPERTY(id, 'IsView') = 1)
DROP VIEW ARTEFACT_VIEW
;
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id('CONTENT_CONSTRAINT_V') AND OBJECTPROPERTY(id, 'IsView') = 1)
DROP VIEW CONTENT_CONSTRAINT_V
;

DROP SEQUENCE IF EXISTS IREF_SEQ
;
-- delete all MSDB foreign key constraints and tables
begin
  DECLARE @sql NVARCHAR(MAX) = N'';

with msdb_tables as (
SELECT name FROM sys.tables where name in (
	'HCL_CODE',
	'HLEVEL',
	'HIERARCHY',
	'HCL',
	'ARTEFACT',
	'ATT_GROUP',
	'CATEGORY',
	'CATEGORY_DATASET',
	'CATEGORY_DB_CONNECTION',
	'CATEGORY_SCHEME',
	'CATEGORY_USER',
	'CODELIST',
	'COM_COL_MAPPING_COLUMN',
	'COM_COL_MAPPING_COMPONENT',
	'COMPONENT',
	'COMPONENT_MAPPING',
	'CONCEPT',
	'CONCEPT_SCHEME',
	'AGENCY',
	'AGENCY_SCHEME',
	'DATACONSUMER',
	'DATACONSUMER_SCHEME',
	'DATAPROVIDER',
	'DATAPROVIDER_SCHEME',
	'ORGANISATION_UNIT',
	'ORGANISATION_UNIT_SCHEME',
	'STRUCTURE_SET',
	'CONNECTION_CATEGORY',
	'CONTACT',
	'CONTACT_DETAIL',
	'DATAFLOW',
	'DATAFLOW_CATEGORY',
	'DATAFLOW_DATASET',
	'DATAFLOW_DB_CONNECTION',
	'DATAFLOW_USER',
	'DATASET_PROPERTY',
	'DATASET_PROPERTY_TYPE',
	'DATASET',
	'TIME_PRE_FORMATED',
	'DATASET_COLUMN',
	'DB_CONNECTION',
	'DB_VERSION',
	'DIM_GROUP',
	'DSD',
	'DSD_CODE',
	'DSD_GROUP',
	'HEADER',
	'HEADER_LOCALISED_STRING',
	'ITEM',
	'LOCAL_CODE',
	'LOCALISED_STRING',
	'MA_USER',
	'MAPPING_SET',
	'PARTY',
	'TRANSCODING',
	'TRANSCODING_CODELIST',
	'TRANSCODING_RULE',
	'TRANSCODING_RULE_DSD_CODE',
	'TRANSCODING_RULE_LOCAL_CODE',
	'TRANSCODING_SCRIPT',
	'ENUMERATIONS',
	'TEXT_FORMAT', 
	'DESC_SOURCE', 
	'TIME_TRANSCODING',
	'CATEGORISATION', 
	'ATTR_DIMS',
	'CODELIST_MAP',
	'CODE_MAP', 
	'STRUCTURE_MAP',
	'COMPONENT_MAP', 
	'ANNOTATION', 
	'ANNOTATION_TEXT', 
	'ARTEFACT_ANNOTATION',
	'ITEM_ANNOTATION',
	'COMPONENT_ANNOTATION', 
	'GROUP_ANNOTATION', 
	'CUBE_REGION', 
	'CONTENT_CONSTRAINT',
	'CONTENT_CONSTRAINT_ATTACHMENT',
	'CUBE_REGION_KEY_VALUE',
	'CUBE_REGION_VALUE',
	'ATT_MEASURE',
	'METADATA_ATTRIBUTE',
	'ITEM_SCHEME',
	'CONCEPT_ROLE',
	'TARGET_OBJECT',
	'COMPONENT_COMMON',
	'METADATA_TARGET',
	'METADATAFLOW',
	'REPORT_STRUCTURE',
	'REPORT_STRUCTURE_META_TARGET',
	'PROVISION_AGREEMENT',
	'STRUCTURE_USAGE',
	'METADATA_STRUCTURE_DEFINITION',
	'CONCEPT_TEXT_FORMAT',
	'REGISTRATION',
	'DATA_SOURCE',
	'CONTENT_CONSTRAINT_SOURCE',
	'REGISTRY',
	'USER_ACTION',
	'TM_TRANSCODING',
	'TM_TIME_TRANSCODING',
	'TEMPLATE_MAPPING',
	'PERIOD_RULES',
	'TIME_COLUMN_CONFIG',
	'TIME_COLUMN_TYPE',
	'TIME_FORMAT_CONFIG',
	'TIME_PARTICLE_CONFIG',
	'TIME_TRANSCODING_TR',
	'DB_TIME_FORMAT',
	'NSIWS',
	'META_COL_MAPPING_COMPONENT',
	-- legacy tables
	'SEQUENCE_ID',
	'NORM_MAPPING',
	'NORMTABLE_MAPPING',
	'NORMCOLUMN_TO_COLUMN',
	'LOCAL_TABLE',
	'LOCAL_COLUMN',
	'ATTACH_TYPES',
	'PROXY_SETTINGS'
)),
constraints as (
select N'ALTER TABLE ' + QUOTENAME(OBJECT_SCHEMA_NAME(parent_object_id))
    + '.' + QUOTENAME(OBJECT_NAME(parent_object_id)) + 
    ' DROP CONSTRAINT ' + QUOTENAME(name) + ';'  + CHAR(13) + CHAR(10) as alterDdl FROM sys.foreign_keys where OBJECT_NAME(parent_object_id) in (select name from msdb_tables) )

select @sql += alterDdl from (select alterDdl from constraints union all select N'DROP TABLE ' + QUOTENAME(name) + ';' + CHAR(13) + CHAR(10) from msdb_tables) a;

execute(@sql);
end
;
GO
;

-- delete all MSDB procedures
begin
DECLARE @sql NVARCHAR(MAX) = N'';
select @sql += N'DROP PROCEDURE ' + QUOTENAME(name) + ';' + CHAR(13) + CHAR(10) from sys.procedures where name in (
'INSERT_DATAFLOW',
'INSERT_CATEGORISATION',
'INSERT_CATEGORY_SCHEME',
'INSERT_CODELIST',
'INSERT_CONCEPT_SCHEME',
'INSERT_AGENCY_SCHEME',
'INSERT_DATACONSUMER_SCHEME',
'INSERT_DATAPROVIDER_SCHEME',
'INSERT_ORGANISATION_UNIT_SCH',
'INSERT_STRUCTURE_SET',
'INSERT_TEXT_FORMAT',
'INSERT_CODELIST_MAP',
'INSERT_CODE_MAP',
'INSERT_STRUCTURE_MAP',
'INSERT_COMPONENT_MAP',
'INSERT_ANNOTATION',
'INSERT_ANNOTATION_TEXT',
'INSERT_ARTEFACT_ANNOTATION',
'INSERT_COMPONENT_COMMON',
'INSERT_ITEM_ANNOTATION',
'INSERT_COMPONENT_ANNOTATION',
'INSERT_GROUP_ANNOTATION',
'INSERT_CONTENT_CONSTRAINT',
'INSERT_CONSTRAINT_ATTACHMENT',
'INSERT_CUBE_REGION',
'INSERT_CUBE_REGION_KEY_VALUE',
'INSERT_CUBE_REGION_VALUE',
'INSERT_REGISTRATION',
'INSERT_DATA_SOURCE',
'INSERT_STRUCTURE_USAGE',
'INSERT_METADATAFLOW',
'INSERT_MSD',
'INSERT_METADATA_TARGET',
'INSERT_TARGET_OBJECT',
'INSERT_REPORT_STRUCTURE',
'INSERT_METADATA_ATTRIBUTE',
'INSERT_PROVISION_AGREEMENT',
'INSERT_LOCAL_CODE',
'UPDATE_TRANSCODING_RULE',
'INSERT_TRANSCODING',
'INSERT_TRANSCODING_SCRIPT',
'INSERT_ITEM',
'INSERT_ARTEFACT',
'INSERT_ITEM_SCHEME',
'INSERT_LOCALISED_STRING',
'INSERT_COMPONENT',
'INSERT_DSD_GROUP',
'INSERT_DSD_CODE',
'INSERT_CATEGORY',
'INSERT_CONCEPT',
'INSERT_AGENCY',
'INSERT_DATACONSUMER',
'INSERT_DATAPROVIDER',
'INSERT_ORGANISATION_UNIT',
'INSERT_HCL_CODE',
'INSERT_HCL',
'INSERT_HIERACHY',
'INSERT_HLEVEL',
'INSERT_DSD',
'INSERT_REGISTRY',
'INSERT_USER_ACTION',
'INSERT_TIME_PARTICLE_CONFIG',
'INSERT_TIME_TRANSCODING_TR',
'PROCESS_EXCLUSIVE_KEY_VALUES',
'PROCESS_INCLUSIVE_KEY_VALUES',
'PROCESS_CONSTRAINTS_INTERNAL',
'PROCESS_CONSTRAINTS',
'INSERT_COMPONENT_MAPPING',
'INSERT_CONTACT',
'INSERT_CONTACT_DETAIL',
'INSERT_DATASET',
'INSERT_DATASET_COLUMN',
'INSERT_DB_CONNECTION',
'INSERT_DESC_SOURCE',
'INSERT_HEADER',
'INSERT_HEADER_LOCALISED_STRING',
'INSERT_MA_USER',
'INSERT_MAPPING_SET',
'INSERT_PARTY',
'INSERT_PROXY_SETTINGS',
'INSERT_TEMPLATE_MAPPING',
'INSERT_TRANSCODING_RULE',
'INSERT_NSIWS',
'INSERT_DATASET_PROPERTY',
'getVersion',
'isEqualVersion',
'isGreaterVersion',
'versionToString',
'SPLIT_VERSION');

EXECUTE(@sql)
end
;

